
; CC5X Version 3.0G, Copyright (c) B. Knudsen Data
; C compiler for the PICmicro family
; ************  20. Mar 2000  22:52  *************

	processor  16C711
	radix  DEC

INDF        EQU   0x00
TMR0        EQU   0x01
OPTION_REG  EQU   0x81
STATUS      EQU   0x03
FSR         EQU   0x04
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
T0SE        EQU   4
T0CS        EQU   5
Carry       EQU   0
Zero_       EQU   2
RP0         EQU   5
T0IF        EQU   2
T0IE        EQU   5
GIE         EQU   7
servo_pin   EQU   0x0F
servo_num   EQU   0x14
position    EQU   0x15
window      EQU   0x16
boogies     EQU   0x17
loops       EQU   0x18
current     EQU   0x19
direction   EQU   0
s1          EQU   0x0C
s2          EQU   0x0D
fsr         EQU   0x0E

	GOTO main

  ; FILE C:\PROGRA~1\MPLAB\SERVOTST.C
			;//===================================================================//
			;//                         SERVOTST.C                                //
			;//===================================================================//
			;//	By:		Dale Botkin <dale@botkin.org>					    //
			;//	Date:	3/15/2000                                             //
			;//-------------------------------------------------------------------//
			;// Simple C program for the PIC MPU, pretty much any variety.  Will  //
			;// exercise up to four R/C servos connected to pins RB0:3.  I tested //
			;// this with three, but it's pretty obvious you need to power the    //
			;// servos separately from the PIC to cut down on glitches.  Very     //
			;// easy to modify for up to 8 servos, though every servo you add     //
			;// sucks up another 10% of available CPU time.  Since all we're      //
			;// doing is exercising them, though, using 80% of CPU time running   //
			;// the pulses is no biggie.                                          //
			;//-------------------------------------------------------------------//
			;// Copyright (C)2000, Dale Botkin, all rights reserved.  You may use //
			;// this code freely for personal, non-commercial use.  In the highly //
			;// unlikely event that you want to use this code for commercial use, //
			;// email me to make arrangements.                                    //
			;//-------------------------------------------------------------------//
			;
			;
			;#include "16C711.H"					// Change for your CPU
			;#include "int16CXX.h"
			;
			;#pragma config WDTE=off, FOSC=XT, BODEN=on
			;#pragma config |= 0x3FB0  			// Code protect off
			;
			;char	servo_pin;					// Variable for port pins
			;char	servo[4];						// Servo position values
			;char	servo_num;					// Pointer to current servo position value
			;char	position;						// Working servo position value
			;char	window;						// 2ms - position value
			;char	boogies;						// Interrupt counter
			;char	loops;						// Loop counter
			;char	current;						// same as servo_num, but outside of interrupt
			;bit	direction;					// direction of travel flag
			;
			;#pragma	origin 4
	ORG 0x0004
			;
			;		// With .1ms resolution, we can control the servo in 10% steps:
			;		// 10 = 0 degrees (or 100% backward motion)		1.0ms
			;		// 11 = 18 degrees (or 80% backward motion)		1.1ms
			;		// 12 = 36 degrees (or 60% backward motion)		1.2ms
			;		// 13 = 54 degrees (or 40% backward motion)		1.3ms
			;		// 14 = 72 degrees (or 20% backward motion)		1.4ms
			;		// 15 = 90 degrees (or stopped)				1.5ms
			;		// 16 = 108 degrees (or 20% forward motion)		1.6ms
			;		// 17 = 126 degrees (or 40% forward motion)		1.7ms
			;		// 18 = 144 degrees (or 60% forward motion)		1.8ms
			;		// 19 = 162 degrees (or 80% forward motion)		1.9ms
			;		// 20 = 180 degrees (or 100% forward motion)		2.0ms
			;		// So our pulse routine needs to run 1ms + x tenths.
			;		// Next version will (maybe) use hundredths, from 100 to 200.
			;
			;interrupt scan_servos() {
scan_servos
			;	PORTA = 2;									// indicate where we are
	MOVLW .2
	BCF   0x03,RP0
	MOVWF PORTA
			;	T0IF = 0;										// Clear TMR0 interrupt flag
	BCF   0x0B,T0IF
			;	int_save_registers								// Save status & W reg
	MOVWF s1
	SWAPF STATUS,W
	MOVWF s2
			;	char fsr; fsr = FSR;							// Save FSR
	MOVF  FSR,W
	MOVWF fsr
			;	OPTION = 8;									// No TMR0 prescaler
	MOVLW .8
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	servo_pin = 1;									// Set up for first servo 
	MOVLW .1
	MOVWF servo_pin
			;	for(servo_num = 0; servo_num <=3; servo_num++) {
	CLRF  servo_num
m001	MOVLW .4
	SUBWF servo_num,W
	BTFSC 0x03,Carry
	GOTO  m007
			;		position = servo[servo_num];					// get pulse width value
	MOVLW .16
	ADDWF servo_num,W
	MOVWF FSR
	MOVF  INDF,W
	MOVWF position
			;		window = 30 - position;						// Figure out remainder of 2ms window
	MOVF  position,W
	SUBLW .30
	MOVWF window
			;		PORTB = servo_pin;							// Turn on servo pin
	MOVF  servo_pin,W
	BCF   0x03,RP0
	MOVWF PORTB
			;	   	TMR0 = 0;									// Clear TMR0
	CLRF  TMR0
			;		do {
			;			TMR0 = 11;							// Adjust for execution time
m002	MOVLW .11
	BCF   0x03,RP0
	MOVWF TMR0
			;			while ( TMR0 < 100 );					// wait 100 uS
m003	MOVLW .100
	BCF   0x03,RP0
	SUBWF TMR0,W
	BTFSS 0x03,Carry
	GOTO  m003
			;		} while( --position > 0 );					// for as many as we need
	DECFSZ position,1
	GOTO  m002
			;		PORTB = 0;								// Turn off all servo pins
	BCF   0x03,RP0
	CLRF  PORTB
			;			// Now we have to burn up the remainder of the 2ms total pulse
			;			// window...
			;		if(window > 0) {
	MOVF  window,1
	BTFSC 0x03,Zero_
	GOTO  m006
			;			do {
			;					TMR0 = 11;					// Adjust for execution time
m004	MOVLW .11
	BCF   0x03,RP0
	MOVWF TMR0
			;				while ( TMR0 < 100 );				// wait 100 uS
m005	MOVLW .100
	BCF   0x03,RP0
	SUBWF TMR0,W
	BTFSS 0x03,Carry
	GOTO  m005
			;			} while(--window > 0);					// for as many as we need
	DECFSZ window,1
	GOTO  m004
			;		}
			;			// And set us up for the next servo in line...
			;		servo_pin = servo_pin*2;						// Set up for next servo in line
m006	BCF   0x03,Carry
	RLF   servo_pin,1
			;	}
	INCF  servo_num,1
	GOTO  m001
			;		
			;		// Now we set up for an 8ms delay until the ext interrupt.
			;		// We just spent 8ms pulsing the servos, so in another 12 we
			;		// need to do it again.
			;	int_restore_registers							// Retrieve the registers
m007	SWAPF s2,W
	MOVWF STATUS
	SWAPF s1,1
	SWAPF s1,W
			;	FSR = fsr;									// Restore FSR
	MOVF  fsr,W
	MOVWF FSR
			;	OPTION = 5;									// 256 prescaler for TMR0
	MOVLW .5
	BSF   0x03,RP0
	MOVWF OPTION_REG
			;	TMR0 = 187;									// Set up for 12ms interrupt
	MOVLW .187
	BCF   0x03,RP0
	MOVWF TMR0
			;	boogies++;									// Increment boogie counter
	INCF  boogies,1
			;	PORTA = 0;
	CLRF  PORTA
			;}
	RETFIE
			;	
			;
			;void main(){
main
			;	T0CS = 0;										// T0 on instruction cycle
	BSF   0x03,RP0
	BCF   0x01,T0CS
			;	T0SE = 1;										// rising edge
	BSF   0x01,T0SE
			;	clearRAM();									// start with clear RAM
	MOVLW .12
	MOVWF FSR
m008	CLRF  INDF
	INCF  FSR,1
	MOVLW .80
	SUBWF FSR,W
	BTFSS 0x03,Carry
	GOTO  m008
			;	PORTA = 0;						
	BCF   0x03,RP0
	CLRF  PORTA
			;	PORTB = 0;									// All outputs off
	CLRF  PORTB
			;	TRISA = 0;
	BSF   0x03,RP0
	CLRF  TRISA
			;	TRISB = 0;									// Port B is all output
	CLRF  TRISB
			;	OPTION = 5;									// Prescaler set to 256
	MOVLW .5
	MOVWF OPTION_REG
			;	direction = 0;										
	BCF   0x1A,direction
			;	
			;		// Set all servo position registers to the 90 degree mid point.
			;	for(current = 0; current < 4; current++) {
	CLRF  current
m009	MOVLW .4
	SUBWF current,W
	BTFSC 0x03,Carry
	GOTO  m010
			;		servo[current] = 15;
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .15
	MOVWF INDF
			;	} 
	INCF  current,1
	GOTO  m009
			;	TMR0 = 131;									// Set up timer for 8ms
m010	MOVLW .131
	BCF   0x03,RP0
	MOVWF TMR0
			;	T0IE = 1;										// Enable TMR0 interrupt
	BSF   0x0B,T0IE
			;	GIE = 1;										// Duh.
	BSF   0x0B,GIE
			;
			;		// The boogie counter gets updated every 20ms, so 50 boogies
			;		// equals one second.  Tip of the hat to bogomips.
			;
			;		// First wait 2 seconds to let us see how the servos do at deadband
			;	while(boogies < 100);							// Loop for 2 seconds
m011	MOVLW .100
	SUBWF boogies,W
	BTFSS 0x03,Carry
	GOTO  m011
			;
			;		// Now do 60 loops of 10% steps once a second, full motion
			;		// range from 10 to 20 and back.  Should take 1 minute.
			;	direction = 1;
	BSF   0x1A,direction
			;	loops = 0;
	CLRF  loops
			;	PORTA = 1;
	MOVLW .1
	BCF   0x03,RP0
	MOVWF PORTA
			;	do {
			;		boogies = 0;								// clear boogie counter
m012	CLRF  boogies
			;		while( boogies < 10 );						// Wait 1/5 second	
m013	MOVLW .10
	SUBWF boogies,W
	BTFSS 0x03,Carry
	GOTO  m013
			;		for(current=0; current < 4; current++) {
	CLRF  current
m014	MOVLW .4
	SUBWF current,W
	BTFSC 0x03,Carry
	GOTO  m017
			;			if(servo[current] == 25) direction = 0;
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVF  INDF,W
	XORLW .25
	BTFSC 0x03,Zero_
	BCF   0x1A,direction
			;			if(servo[current] == 5) direction = 1;
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVF  INDF,W
	XORLW .5
	BTFSC 0x03,Zero_
	BSF   0x1A,direction
			;			if(direction == 0) servo[current]--;
	BTFSC 0x1A,direction
	GOTO  m015
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	DECF  INDF,1
			;			if(direction == 1) servo[current]++;
m015	BTFSS 0x1A,direction
	GOTO  m016
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	INCF  INDF,1
			;		}
m016	INCF  current,1
	GOTO  m014
			;	} while(++loops < 60);
m017	INCF  loops,1
	MOVLW .60
	SUBWF loops,W
	BTFSS 0x03,Carry
	GOTO  m012
			;
			;		// Now recenter the servos for 2 seconds 
			;	for(current=0; current < 4; current++) {
	CLRF  current
m018	MOVLW .4
	SUBWF current,W
	BTFSC 0x03,Carry
	GOTO  m019
			;		servo[current] = 15;
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .15
	MOVWF INDF
			;	}		
	INCF  current,1
	GOTO  m018
			;	boogies = 0;
m019	CLRF  boogies
			;	while(boogies < 100);
m020	MOVLW .100
	SUBWF boogies,W
	BTFSS 0x03,Carry
	GOTO  m020
			;
			;		// Now we finish up with 10 full-travel swings, 10 to 20,
			;		// with a 2-second delay in between. 
			;
			;	loops = 0;
	CLRF  loops
			;	PORTA = 0xD;
	MOVLW .13
	BCF   0x03,RP0
	MOVWF PORTA
			;	do {
			;		boogies = 0;
m021	CLRF  boogies
			;		while(boogies < 100);						// 2 second delay
m022	MOVLW .100
	SUBWF boogies,W
	BTFSS 0x03,Carry
	GOTO  m022
			;		for(current=0; current < 4; current++) {
	CLRF  current
m023	MOVLW .4
	SUBWF current,W
	BTFSC 0x03,Carry
	GOTO  m029
			;			if(servo[current] == 25) direction = 0;
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVF  INDF,W
	XORLW .25
	BTFSS 0x03,Zero_
	GOTO  m024
	BCF   0x1A,direction
			;			else if(servo[current] == 5) direction = 1;
	GOTO  m026
m024	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVF  INDF,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m025
	BSF   0x1A,direction
			;			else if(servo[current] > 5 && servo[current] < 25) direction = 0;
	GOTO  m026
m025	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .6
	SUBWF INDF,W
	BTFSS 0x03,Carry
	GOTO  m026
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .25
	SUBWF INDF,W
	BTFSS 0x03,Carry
	BCF   0x1A,direction
			;			if(direction == 0) servo[current] = 5;
m026	BTFSC 0x1A,direction
	GOTO  m027
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .5
	MOVWF INDF
			;			if(direction == 1) servo[current] = 25;
m027	BTFSS 0x1A,direction
	GOTO  m028
	MOVLW .16
	ADDWF current,W
	MOVWF FSR
	MOVLW .25
	MOVWF INDF
			;		}
m028	INCF  current,1
	GOTO  m023
			;	} while(++loops < 10);
m029	INCF  loops,1
	MOVLW .10
	SUBWF loops,W
	BTFSS 0x03,Carry
	GOTO  m021
			;
			;		// And loop forever.
			;	main();
	GOTO  main
			;}

	ORG 0x2007
	DATA 3FF1H
	END
